/* 
 This file was generated by Dashcode.  
 You may edit this file to customize your widget or web page 
 according to the license.txt file included in the project.
 */

//
// Function: load()
// Called by HTML body element's onload event when the widget is ready to start
//
function load()
{
    dashcode.setupParts();
}

//
// Function: remove()
// Called when the widget has been removed from the Dashboard
//
function remove()
{
    // Stop any timers to prevent CPU usage
    // Remove any preferences as needed
    // widget.setPreferenceForKey(null, dashcode.createInstancePreferenceKey("your-key"));
}

//
// Function: hide()
// Called when the widget has been hidden
//
function hide()
{
    // Stop any timers to prevent CPU usage
}

//
// Function: show()
// Called when the widget has been shown
//
function show()
{
    // Restart any timers that were stopped on hide
}

//
// Function: sync()
// Called when the widget has been synchronized with .Mac
//
function sync()
{
    // Retrieve any preference values that you need to be synchronized here
    // Use this for an instance key's value:
    // instancePreferenceValue = widget.preferenceForKey(null, dashcode.createInstancePreferenceKey("your-key"));
    //
    // Or this for global key's value:
    // globalPreferenceValue = widget.preferenceForKey(null, "your-key");
}

//
// Function: showBack(event)
// Called when the info button is clicked to show the back of the widget
//
// event: onClick event from the info button
//
function showBack(event)
{
    var front = document.getElementById("front");
    var back = document.getElementById("back");

    if (window.widget) {
        widget.prepareForTransition("ToBack");
    }

    front.style.display = "none";
    back.style.display = "block";

    if (window.widget) {
        setTimeout('widget.performTransition();', 0);
    }
}

//
// Function: showFront(event)
// Called when the done button is clicked from the back of the widget
//
// event: onClick event from the done button
//
function showFront(event)
{
    var front = document.getElementById("front");
    var back = document.getElementById("back");

    if (window.widget) {
        widget.prepareForTransition("ToFront");
    }

    front.style.display="block";
    back.style.display="none";

    if (window.widget) {
        setTimeout('widget.performTransition();', 0);
    }
}

if (window.widget) {
    widget.onremove = remove;
    widget.onhide = hide;
    widget.onshow = show;
    widget.onsync = sync;
}

function ChangdMod(event)
{
    update();
}

function makeVoid(event)
{
    var modField = document.getElementById("modifierField");	
    modField.value = "void";
    update();

}

function ChangeMatName(event)
{
    update();
}

function ChangeTDField(event)
{
    var Td = document.getElementById("tdField");	
    var tdSlider = document.getElementById("tdSlider");	
    var newValue = checkTd(constrain(tdField.value));
    tdField.value = newValue;
    tdSlider.value = newValue*1000;
    update();
}

function ChangeTDSlider(event)
{
    var tdSlider = document.getElementById("tdSlider");	
    var tdField = document.getElementById("tdField");
    var newValue = checkTd(tdSlider.value/1000);
    tdField.value = newValue;
    tdSlider.value = newValue*1000;
    update();
}

function ChangeTSField(event)
{
    var Ts = document.getElementById("tsField");	
    var tsSlider = document.getElementById("tsSlider");	
    var newValue = checkTs(constrain(tsField.value));
    tsField.value = newValue;
    tsSlider.value = newValue*1000;
    update();
}

function ChangeTSSlider(event)
{
    var tsSlider = document.getElementById("tsSlider");	
    var tsField = document.getElementById("tsField");
    var newValue = checkTs(tsSlider.value/1000);
    tsField.value = newValue;
    tsSlider.value = newValue*1000;
    update();
}

function ChangeRDField(event)
{
    var Rd = document.getElementById("rdField");	
    var rdSlider = document.getElementById("rdSlider");	
    var newValue = checkRd(constrain(rdField.value));
    rdField.value = newValue;
    rdSlider.value = newValue*1000;
    update();
}

function ChangeRDSlider(event)
{
    var rdSlider = document.getElementById("rdSlider");	
    var rdField = document.getElementById("rdField");
    var newValue = checkRd(rdSlider.value/1000);
    rdField.value = newValue;
    rdSlider.value = newValue*1000;
    update();
}

function ChangeRSField(event)
{
    var Rs = document.getElementById("rsField");	
    var rsSlider = document.getElementById("rsSlider");	
    var newValue = checkRs(constrain(rsField.value));
    rsField.value = newValue;
    rsSlider.value = newValue*1000;
    update();
}

function ChangeRSSlider(event)
{
    var rsSlider = document.getElementById("rsSlider");	
    var rsField = document.getElementById("rsField");
    var newValue = checkRs(rsSlider.value/1000);
    rsField.value = newValue;
    rsSlider.value = newValue*1000;
    update();
}

function ChangeRoughField(event)
{
    var rough = document.getElementById("roughField");	
    var roughSlider = document.getElementById("roughSlider");	
    var newValue = constrain(rough.value);
    rough.value = newValue;
    roughSlider.value = newValue*1000;
    update();
}

function ChangeRoughSlider(event)
{
    var roughSlider = document.getElementById("roughSlider");	
    var rough = document.getElementById("roughField");
    var newValue = roughSlider.value/1000;
    rough.value = newValue;
    update();
}


function constrain(value)
{
    if (value>1) {
        return 1;
    }else if (value>=0 && value<=1) {
        return value;
    }else {
        return 0;
    }
}

function getTRds()
{
    var Td = document.getElementById("tdField");
    var Ts = document.getElementById("tsField");
    var Rd = document.getElementById("rdField");
    var Rs = document.getElementById("rsField");

    var TRds = [parseFloat(Td.value),parseFloat(Ts.value),parseFloat(Rd.value),parseFloat(Rs.value)];
    return TRds;
}

function checkTd(newValue)
{   
    var TRds = getTRds();
    var maxRs = Math.floor((1-TRds[1]-TRds[2]-TRds[3])*1000)/1000;
    if (newValue>maxRs) {
        return maxRs;
    }else {
        return newValue;
    }	
}

function checkTs(newValue)
{   
    var TRds = getTRds();
    var maxTs = Math.floor((1-TRds[0]-TRds[2]-TRds[3])*1000)/1000;
    if (newValue>maxTs) {
        return maxTs;
    }else {
        return newValue;
    }	
}

function checkRd(newValue)
{   
    var TRds = getTRds();
    var maxRs = Math.floor((1-TRds[0]-TRds[1]-TRds[3])*1000)/1000;
    if (newValue>maxRs) {
        return maxRs;
    }else {
        return newValue;
    }	
}

function checkRs(newValue)
{   
    var TRds = getTRds();
    var maxRs = Math.floor((1-TRds[0]-TRds[1]-TRds[2])*1000)/1000;
    if (newValue>maxRs) {
        return maxRs;
    }else {
        return newValue;
    }	
}

function update()
{
    var modifier = document.getElementById("modifierField");
    var matName = document.getElementById("matNameField");
    var rough = document.getElementById("roughField");

    var TRds = getTRds();
    var Td = TRds[0];
    var Ts = TRds[1];
    var Rd = TRds[2];
    var Rs = TRds[3];
    absorb.value = Math.floor((1-Td-Ts-Rd-Rs)*1000+.5)/1000;

    //Calculate A1-A7
    var A7 = Math.floor((Ts/(Td+Ts))*1000+.5)/1000;
    var A6 = Math.floor(((Td+Ts)/(Rd+Td+Ts))*1000+.5)/1000;
    var A5 = Math.floor((rough.value)*1000+.5)/1000;
    var A4 = Math.floor((Rs)*1000+.5)/1000;
    var A3 = Math.floor((Rd/((1-Rs)*(1-(Td+Ts)/(Rd+Td+Ts))))*1000+.5)/1000;
    var A2 = Math.floor((Rd/((1-Rs)*(1-(Td+Ts)/(Rd+Td+Ts))))*1000+.5)/1000;    
    var A1 = Math.floor((Rd/((1-Rs)*(1-(Td+Ts)/(Rd+Td+Ts))))*1000+.5)/1000;

    //Generate Display Text
    var textAreaToChange = document.getElementById("textarea");

    if(Td+Ts==0){
        var newTextAreaText = "#Td="+Td+" Ts="+Ts+" Rd="+Rd+" Rs="+Rs+"\n"+modifier.value+" plastic "+matName.value+"\n0\n0\n5 "+A1+" "+A2+" "+A3+" "+A4+" "+A5;	   
    }else {
        var newTextAreaText = "#Td="+Td+" Ts="+Ts+" Rd="+Rd+" Rs="+Rs+"\n"+modifier.value+" trans "+matName.value+"\n0\n0\n7 "+A1+" "+A2+" "+A3+" "+A4+" "+A5+" "+A6+" "+A7;	
    }			

    // Text area code
    textAreaToChange.value = newTextAreaText;
}

function copyMaterial(event) {
    var MaterialDefinition = document.getElementById("textarea");
	var dataForPasteboard = MaterialDefinition.value;
	widget.system("/bin/echo -n '"+dataForPasteboard+"' | /usr/bin/pbcopy", function () {});
}

